diff --git a/src/main/java/net/minecraft/core/item/SeedsItem.java b/src/main/java/net/minecraft/core/item/SeedsItem.java
index a81fc1920..aa6f45789 100644
--- a/src/main/java/net/minecraft/core/item/SeedsItem.java
+++ b/src/main/java/net/minecraft/core/item/SeedsItem.java
@@ -24,13 +24,13 @@ public class SeedsItem extends Item {
 			blockZ += side.getOffsetZ();
 		}
 		if(world.getBlockId(blockX, blockY - 1, blockZ) == Blocks.FARMLAND_DIRT.id && world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
-			world.setBlockWithNotify(blockX, blockY, blockZ, cropsId);
-			world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.blocksList[cropsId], EnumBlockSoundEffectType.PLACE);
-			itemstack.consumeItem(entityplayer);
-			return true;
-		} else {
-			return false;
+			if(world.setBlockWithNotify(blockX, blockY, blockZ, cropsId)) {
+				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.blocksList[cropsId], EnumBlockSoundEffectType.PLACE);
+				itemstack.consumeItem(entityplayer);
+				return true;
+			}
 		}
+		return false;
 	}
 
 }
diff --git a/src/main/java/net/minecraft/core/item/block/BlockItem.java b/src/main/java/net/minecraft/core/item/block/BlockItem.java
index d91d457c5..78fbdf5fc 100644
--- a/src/main/java/net/minecraft/core/item/block/BlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/BlockItem.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.FluidBlock;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.Item;
@@ -9,8 +8,6 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
-
 // Referenced classes of package net.minecraft.src:
 //            Item, Block, World, ItemStack, 
 //            Material, StepSound, Player
@@ -33,35 +30,35 @@ public class BlockItem extends Item
     }
 
     @Override
-	public boolean onUseItemOnBlock(ItemStack stack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack stack, Player player, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
 		if(stack.stackSize <= 0) {
 			return false;
 		}
-		if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
-			blockX += side.getOffsetX();
-			blockY += side.getOffsetY();
-			blockZ += side.getOffsetZ();
+		if(!world.canPlaceInsideBlock(x, y, z)) {
+			x += side.getOffsetX();
+			y += side.getOffsetY();
+			z += side.getOffsetZ();
 		}
-        Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-        boolean placedInside = currentBlock != null && !(currentBlock instanceof FluidBlock);
-
-        if(blockY < 0 || blockY >= world.getHeightBlocks()) {
-        	return false;
-        }
-		if(world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
+		if(y < 0 || y >= world.getHeightBlocks()) {
+			return false;
+		}
+		if(world.canBlockBePlacedAt(blockID, x, y, z, false, side)) {
 			Block block = Block.blocksList[blockID];
-            if (placedInside && !world.isClientSide){
-                world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
-            }
-			if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(stack.getMetadata()))) {
-				block.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
-				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
-
+			int meta = getPlacedBlockMetadata(player, stack, world, x, y, z, side, xPlaced, yPlaced);
+			if(world.setBlockAndMetadataWithNotify(x, y, z, blockID, meta)) {
+				stack.consumeItem(player);
+				block.onBlockPlacedByMob(world, x, y, z, side, player, yPlaced);
+				world.playBlockSoundEffect(player, x + 0.5F, y + 0.5F, z + 0.5F, block, EnumBlockSoundEffectType.PLACE);
+				return true;
 			}
-			return true;
 		}
 		return false;
 	}
+    
+    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced)
+    {
+    	return Block.getBlock(blockID).getPlacedBlockMetadata(player, stack, world, x, y, z, side, xPlaced, yPlaced);
+    }
 
     @Override
     public String getLanguageKey(ItemStack itemstack)
diff --git a/src/main/java/net/minecraft/core/item/block/BlockItemStairsPainted.java b/src/main/java/net/minecraft/core/item/block/BlockItemStairsPainted.java
index 0e8b4d768..c275a0a64 100644
--- a/src/main/java/net/minecraft/core/item/block/BlockItemStairsPainted.java
+++ b/src/main/java/net/minecraft/core/item/block/BlockItemStairsPainted.java
@@ -1,8 +1,11 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
 
 public class BlockItemStairsPainted extends BlockItem
 {
@@ -15,11 +18,10 @@ public class BlockItemStairsPainted extends BlockItem
     }
 
     @Override
-    public int getPlacedBlockMetadata(int i)
-    {
-        return i;
+    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+    	return stack.getMetadata();
     }
-
+    
     @Override
     public String getLanguageKey(ItemStack itemstack) {
         return super.getKey() + "." + DyeColor.colorFromBlockMeta((itemstack.getMetadata() & 0xF0) >> 4).colorID;
diff --git a/src/main/java/net/minecraft/core/item/block/LadderBlockItem.java b/src/main/java/net/minecraft/core/item/block/LadderBlockItem.java
index f0e9a6904..00858722e 100644
--- a/src/main/java/net/minecraft/core/item/block/LadderBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/LadderBlockItem.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.FluidBlock;
 import net.minecraft.core.block.LadderBlock;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -9,8 +8,6 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
-
 public class LadderBlockItem extends BlockItem {
 
 	private LadderBlock ladderBlock;
@@ -56,11 +53,7 @@ public class LadderBlockItem extends BlockItem {
 	}
 	
 	public boolean placeBlock(World world, int x, int y, int z, int meta, Player player, ItemStack stack, Side side, double sideHeight) {
-		Block currentBlock = world.getBlock(x, y, z);
 		if(world.canPlaceInsideBlock(x, y, z) && world.canBlockBePlacedAt(blockID, x, y, z, false, side) && stack.consumeItem(player)) {
-			if (currentBlock != null && !(currentBlock instanceof FluidBlock) && !world.isClientSide){
-				world.playSoundEffect(EVENT_BLOCK_BREAK, x, y, z, world.getBlockId(x, y, z));
-			}
 			if(world.setBlockAndMetadataWithNotify(x, y, z, blockID, meta)) {
 				Block.getBlock(blockID).onBlockPlacedByMob(world, x, y, z, side, player, sideHeight);
 				world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, ladderBlock, EnumBlockSoundEffectType.PLACE);
diff --git a/src/main/java/net/minecraft/core/item/block/LampBlockItem.java b/src/main/java/net/minecraft/core/item/block/LampBlockItem.java
index 7ae72fe8b..f088b21b4 100644
--- a/src/main/java/net/minecraft/core/item/block/LampBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/LampBlockItem.java
@@ -1,9 +1,11 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.LampBlock;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
 
 public class LampBlockItem extends BlockItem
 {
@@ -14,11 +16,10 @@ public class LampBlockItem extends BlockItem
         setMaxDamage(0);
         setHasSubtypes(true);
     }
-
+    
     @Override
-    public int getPlacedBlockMetadata(int i)
-    {
-        return i;
+    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+    	return stack.getMetadata();
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/item/block/LayerBlockItem.java b/src/main/java/net/minecraft/core/item/block/LayerBlockItem.java
index c18181e8b..03a60d60e 100644
--- a/src/main/java/net/minecraft/core/item/block/LayerBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/LayerBlockItem.java
@@ -1,12 +1,12 @@
 package net.minecraft.core.item.block;
 
+import net.minecraft.core.block.BaseLayerBlock;
+
 // Referenced classes of package net.minecraft.src:
 //            Item, Block, World, ItemStack,
 //            Material, StepSound, Player
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.FluidBlock;
-import net.minecraft.core.block.BaseLayerBlock;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -15,8 +15,6 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
-import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
-
 
 public class LayerBlockItem extends BlockItem
 {
@@ -127,18 +125,14 @@ public class LayerBlockItem extends BlockItem
 		if (world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
 		{
 			final Block block = Block.blocksList[blockID];
-			Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-			boolean placedInside = currentBlock != null && !(currentBlock instanceof FluidBlock);
-			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(itemstack.getMetadata())))
+			int placeMeta = getPlacedBlockMetadata(entityplayer, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
 			{
-				if (placedInside && !world.isClientSide){
-					world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, currentBlock.id);
-				}
 				Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, null, entityplayer, yPlaced);
 				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				itemstack.consumeItem(entityplayer);
+				return true;
 			}
-			return true;
 		}
 		return false;
 
diff --git a/src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java b/src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java
index cc989411a..9179e3f21 100644
--- a/src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java
@@ -1,11 +1,8 @@
-
 package net.minecraft.core.item.block;
 
-
+import net.minecraft.core.block.BaseLayerBlock;
 import net.minecraft.core.block.BaseLeavesBlock;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.FluidBlock;
-import net.minecraft.core.block.BaseLayerBlock;
 import net.minecraft.core.block.LeavesLayerBlock;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
@@ -15,8 +12,6 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
-import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
-
 public class LeavesLayerBlockItem extends BlockItem
 {
 	public LeavesLayerBlockItem(Block block)
@@ -126,21 +121,22 @@ public class LeavesLayerBlockItem extends BlockItem
 		if (world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
 		{
 			final Block block = Block.blocksList[blockID];
-			Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-			boolean placedInside = currentBlock != null && !(currentBlock instanceof FluidBlock);
-			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, LeavesLayerBlock.setPermanent(getPlacedBlockMetadata(itemstack.getMetadata()), true)))
+			int placeMeta = getPlacedBlockMetadata(entityplayer, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
 			{
-				if (placedInside && !world.isClientSide){
-					world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, currentBlock.id);
-				}
 				Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, null, entityplayer, yPlaced);
 				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				itemstack.consumeItem(entityplayer);
+				return true;
 			}
-			return true;
 		}
 		return false;
 
 	}
+	
+	@Override
+	public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+		return LeavesLayerBlock.MASK_PERMANENT;
+	}
 
 }
diff --git a/src/main/java/net/minecraft/core/item/block/PaintedBlockItem.java b/src/main/java/net/minecraft/core/item/block/PaintedBlockItem.java
index 2114d28ab..1d6c38d55 100644
--- a/src/main/java/net/minecraft/core/item/block/PaintedBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/PaintedBlockItem.java
@@ -1,13 +1,6 @@
 package net.minecraft.core.item.block;
 
-
-// Referenced classes of package net.minecraft.src:
-//            BlockItem, Block, BlockCloth, DyeItem,
-//            ItemStack
-
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.WoolBlock;
-import net.minecraft.core.item.DyeItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 
@@ -23,12 +16,6 @@ public class PaintedBlockItem extends BlockItem
         this.upperMetadata = upperMetadata;
     }
 
-    @Override
-    public int getPlacedBlockMetadata(int i)
-    {
-        return i;
-    }
-
     @Override
     public String getLanguageKey(ItemStack itemstack)
     {
diff --git a/src/main/java/net/minecraft/core/item/block/PaintedSlabBlockItem.java b/src/main/java/net/minecraft/core/item/block/PaintedSlabBlockItem.java
index 072e58c9c..6ff077e1a 100644
--- a/src/main/java/net/minecraft/core/item/block/PaintedSlabBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/PaintedSlabBlockItem.java
@@ -1,13 +1,6 @@
 package net.minecraft.core.item.block;
 
-
-// Referenced classes of package net.minecraft.src:
-//            BlockItem, Block, BlockCloth, DyeItem,
-//            ItemStack
-
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.WoolBlock;
-import net.minecraft.core.item.DyeItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 
@@ -23,12 +16,6 @@ public class PaintedSlabBlockItem extends SlabBlockItem
         this.upperMetadata = true;
     }
 
-    @Override
-    public int getPlacedBlockMetadata(int i)
-    {
-        return i;
-    }
-
     @Override
     public String getLanguageKey(ItemStack itemstack)
     {
diff --git a/src/main/java/net/minecraft/core/item/block/SlabBlockItem.java b/src/main/java/net/minecraft/core/item/block/SlabBlockItem.java
index 741b98835..cba832a33 100644
--- a/src/main/java/net/minecraft/core/item/block/SlabBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/SlabBlockItem.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.FluidBlock;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -9,8 +8,6 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
-
-import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
 public class SlabBlockItem extends BlockItem
 {
 
@@ -88,18 +85,14 @@ public class SlabBlockItem extends BlockItem
         if(world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
         {
             Block block = Block.blocksList[blockID];
-            Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-            boolean placedInside = currentBlock != null && !(currentBlock instanceof FluidBlock);
-            if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(itemstack.getMetadata())))
+            int placeMeta = getPlacedBlockMetadata(entityplayer, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+            if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
             {
-                if (placedInside && !world.isClientSide){
-                    world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, currentBlock.id);
-                }
             	Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, entityplayer, yPlaced);
                 world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(entityplayer);
+				return true;
             }
-            return true;
         }
         return false;
     }
diff --git a/src/main/java/net/minecraft/core/item/tool/ShovelToolItem.java b/src/main/java/net/minecraft/core/item/tool/ShovelToolItem.java
index 9a2da802b..a19e2d050 100644
--- a/src/main/java/net/minecraft/core/item/tool/ShovelToolItem.java
+++ b/src/main/java/net/minecraft/core/item/tool/ShovelToolItem.java
@@ -41,9 +41,7 @@ public class ShovelToolItem extends ToolItem
                 itemstack.damageItem(1, entityplayer);
             }
             return true;
-        } else
-        {
-            return false;
         }
+        return false;
     }
 }
diff --git a/src/main/java/net/minecraft/core/util/helper/Buffer.java b/src/main/java/net/minecraft/core/util/helper/Buffer.java
index a4e74e29d..f6e3a2ba1 100644
--- a/src/main/java/net/minecraft/core/util/helper/Buffer.java
+++ b/src/main/java/net/minecraft/core/util/helper/Buffer.java
@@ -8,7 +8,7 @@ public abstract class Buffer {
 	
 	public static ByteBuffer buffer = createBuffer(2097152);
 	
-	private static ByteBuffer createBuffer(int size) {
+	public static ByteBuffer createBuffer(int size) {
 		return ByteBuffer.allocateDirect(size).order(ByteOrder.nativeOrder());
 	}
 	
diff --git a/src/main/java/net/minecraft/core/world/Dimension.java b/src/main/java/net/minecraft/core/world/Dimension.java
index e3f8a6bda..45cdd1625 100644
--- a/src/main/java/net/minecraft/core/world/Dimension.java
+++ b/src/main/java/net/minecraft/core/world/Dimension.java
@@ -96,7 +96,7 @@ public class Dimension
 	}
 	public static void init(){
 		overworld = new Dimension("overworld", null, 1.0f, -1, WorldTypes.OVERWORLD_DEFAULT);
-		nether = new Dimension("hell", overworld, 0.125f, Blocks.PORTAL_NETHER.id, WorldTypes.NETHER_DEFAULT);
+		nether = new Dimension("nether", overworld, 0.125f, Blocks.PORTAL_NETHER.id, WorldTypes.NETHER_DEFAULT);
 		paradise = new Dimension("paradise", overworld, 8.0f, Blocks.PORTAL_PARADISE.id, WorldTypes.PARADISE_DEFAULT);
 
 		registerDimension(0, overworld);
diff --git a/src/main/java/net/minecraft/core/world/save/conversion/ChunkConverter.java b/src/main/java/net/minecraft/core/world/save/conversion/ChunkConverter.java
index 396ad1f6c..5ed319489 100644
--- a/src/main/java/net/minecraft/core/world/save/conversion/ChunkConverter.java
+++ b/src/main/java/net/minecraft/core/world/save/conversion/ChunkConverter.java
@@ -266,7 +266,7 @@ public class ChunkConverter
 			converters[0].addMapping(new MappingSimple(88, 810)); //Block.soulsand.blockID));
 			converters[0].addMapping(new MappingSimple(89, 820)); //Block.glowstone.blockID));
 			converters[0].addMapping(new MappingSimple(90, 830)); //Block.portalNether.blockID));
-			converters[0].addMapping(new MappingSimple(91, 831)); //Block.pumpkinCarvedActive.blockID));
+			converters[0].addMapping(new MappingSimple(91, 792)); //Block.pumpkinCarvedActive.blockID));
 			converters[0].addMapping(new MappingSimple(92, 840)); //Block.cake.blockID));
 			converters[0].addMapping(new MappingSimple(93, 510)); //Block.repeaterIdle.blockID));
 			converters[0].addMapping(new MappingSimple(94, 511)); //Block.repeaterActive.blockID));
